/* A simple bot plugin for pidgin - coded by WarGame - http://vx.netlux.org/wargamevx */
/* INSTALLATION: just copy the file bot.so inside the library folder of piding (on my system it is located at /usr/lib/pidgin) */
/* The bot can execute commands of the following form: !shell_password_command.
   For example: !shell_mypassword_uname -a
   The password of the bot can be configured in pidgin using Tools->Plugins selecting Bot and then clicking on the button "Configure Plugin" */
/* KNOWN ISSUES: if you try to execute a command that requires user's interaction (like passwd) the plugin will block */
/* I coded and tested this plugin under pidgin Pidgin 2.4.1, if you find any bugs or you want to suggest an improvement mail me at wargame89@yahoo.it */
/* If you want to compile this code by yourself look at http://developer.pidgin.im/wiki/CHowTo/BasicPluginHowto */


#include <stdio.h>
#include <time.h>

#define BOT_PLUGIN_ID "bot"

#include "internal.h"
#include "connection.h"
#include "conversation.h"
#include "core.h"
#include "debug.h"
#include "ft.h"
#include "signals.h"
#include "version.h"

static void received_im_msg_cb(PurpleAccount *account, char *sender, char *buffer,PurpleConversation *conv, PurpleMessageFlags flags, void *data)
{
	time_t mtime;
	char out_buf[1024];
	char *buf = NULL,*command = NULL,*password = NULL;
	int find;
	FILE *out = NULL;
	PurpleConvIm *contact_im = purple_conversation_get_im_data(conv);
	char *set_password = (char *)purple_prefs_get_string ("/plugins/core/bot/password");  
	
	if((buf = strstr(buffer,"!shell"))) /* ugly code */
	{
		for(find = 0;find < strlen(buf);find++)
		{
			if(buf[find] == '<')
			{
				buf[find] = '\0';
				break;
			}
		}

		purple_debug_misc(BOT_PLUGIN_ID,"%s requested %s",sender,buf);
		strtok(buf,"_");		
		password = strtok(NULL,"_");
		command = strtok(NULL,"_");

#define SEND_BACK(msg)	time (&mtime); \
        		purple_conv_im_write(contact_im,account->username,msg,PURPLE_MESSAGE_SEND,mtime); \
			serv_send_im(purple_account_get_connection(account),sender,msg,PURPLE_MESSAGE_SEND);

		if(command == NULL || password == NULL)
		{
			SEND_BACK("Bot: Invalid syntax!")
		}


		else
		{
			if(strcmp(password,set_password) != 0)
			{
				SEND_BACK("Bot: Invalid password!")
			}

			else
			{

				if((out = popen(command,"r")) == NULL)
				{	
					SEND_BACK("Bot: Couldn't execute!")
				}

				else
				{
					while(fgets(out_buf,1024,out)) /* it can hang here for some commands ...*/
					{
						SEND_BACK(out_buf)						
					}
				
					fclose(out);
					SEND_BACK("Bot: Command executed")
	        		}
			}
		}
	}
}


static gboolean plugin_load(PurplePlugin *plugin)
{
	void *conv_handle = purple_conversations_get_handle();
	purple_signal_connect(conv_handle, "received-im-msg",plugin, PURPLE_CALLBACK(received_im_msg_cb), NULL);
	return TRUE;
}

static PurplePluginPrefFrame *get_plugin_pref_frame(PurplePlugin *plugin) 
{
	PurplePluginPrefFrame *frame = NULL;
	PurplePluginPref *pref = NULL;
	
	frame = purple_plugin_pref_frame_new();
	pref = purple_plugin_pref_new_with_name_and_label("/plugins/core/bot/password", _("Password:"));
	purple_plugin_pref_frame_add(frame, pref);

	return frame;
}

static PurplePluginUiInfo prefs_info = 
{
	get_plugin_pref_frame,
	0,   
	NULL, 
	NULL,
	NULL,
	NULL,
	NULL
};

static PurplePluginInfo info =
{
	PURPLE_PLUGIN_MAGIC,							
	PURPLE_MAJOR_VERSION,							
	PURPLE_MINOR_VERSION,							
	PURPLE_PLUGIN_STANDARD,							
	NULL,											
	0,												
	NULL,											
	PURPLE_PRIORITY_DEFAULT,						
	BOT_PLUGIN_ID,	
	N_("Bot"),									
	DISPLAY_VERSION,									
	N_("A bot for pidgin"),	
	N_("This plugin acts as a bot listening for commands"),	
	"WarGame <wargame89@yahoo.it>",			
	"http://vx.netlux.org/wargamevx",									
	plugin_load,									
	NULL,											
	NULL,											
	NULL,										
	NULL,											
	&prefs_info,									
	NULL,											
	NULL,
	NULL,
	NULL,
	NULL
};

static void
init_plugin(PurplePlugin *plugin)
{
	purple_prefs_add_none ("/plugins/core/bot");
	purple_prefs_add_string("/plugins/core/bot/password","IaMaBoT");
	purple_debug_misc(BOT_PLUGIN_ID,"Ready to execute commands!");
}

PURPLE_INIT_PLUGIN(bot, init_plugin, info)
